/*
 * Compilation: g++ -std=c++17 arrays.cpp -o arrays
 * Execution: ./arrays
 */

#include <iostream>

int dotProduct(int A[], int B[], int n) {
    int result = 0;
    for (int i = 0; i < n; i++) {
        result += A[i] * B[i];
    }
    return result;
}

int median(int A[], int n) {
    int B[n];
    for (int i = 0; i < n; i++) {
        B[i] = A[i];
    }
    std::sort(B, B+n-1);
    if (n % 2 == 0) {
        return (B[n/2] + B[n/2-1]) / 2;
    } else {
        return B[n/2];
    }
}

void printIntArray(int A[], int n, std::string prefix="", std::string suffix="\n") {
    std::cout << prefix << "[";
    for (int i = 0; i < n; i++) {
        std::cout << A[i];
        if (i < n - 1) {
            std::cout << ", ";
        }
    }
    std::cout << "]" << suffix;
}

int main() {

    int A[] = {0, 1, 1, 2, 3, 5, 8, 13, 21, 34, 55};
    printIntArray(A, 11);

    int B[5];
    B[0] = 1;
    B[1] = 5;
    B[2] = 1;
    B[3] = 1;
    B[4] = 2;

    printIntArray(B, 2, "n < len(B): ");
    printIntArray(B, 5, "n = len(B): ");
    printIntArray(B, 7, "n > len(B): ", " (what!?!)\n");


    int C[] = {1, 2, 3};
    int D[] = {4, 5, 6};
    printIntArray(C, 3, "Dot Product: ", " • ");
    printIntArray(D, 3, "", " = ");
    std::cout << dotProduct(C, D, 3) << "\n";

    int E[] = {55, -56, 81, -2, -11, 65, 6, -38, -27, -29};
    printIntArray(E, 10);
    std::cout << "Median: " << median(E, 10) << "\n";
}