/*
 * Compilation: g++ -std=c++17 digits.cpp -o digits
 * Execution: ./digits 15112
 */

#include <iostream>

int digitCount(int n) {
    n = std::abs(n);
    if (n == 0) {
        return 1;
    }
    int count = 0;
    while (n > 0) {
        count++;
        n /= 10;
    }
    return count;
}

int exponentiate(int base, int exp) {
    int result = 1;
    for (int i = 0; i < exp; i++) {
        result *= base;
    }
    return result;
}

int getKthDigit(int n, int k) {
    return (std::abs(n) / exponentiate(10, k)) % 10;
}


int main(int argc, char **argv) {
    if (argc != 2) {
        std::cout << "Expected 1 command line argument (got " << (argc - 1) << ")\n";
        return 0;
    }

    int n = atoi(argv[1]);
    int count = digitCount(n);

    std::cout << "n: " << n << "\n";
    
    std::cout << "digitCount(" << n << "): " << count << "\n";

    std::cout << "digits of " << n << ": ";
    for (int k = count-1; k >= 0; k--) {
        std::cout << "" << getKthDigit(n, k);
        if (k > 0) {
            std::cout << ", ";
        } else {
            std::cout << "\n";
        }
    }


}