/*
    Compilation: g++ -std=c++17 pointers.cpp -o pointers
    Execution: ./pointers 55 -56 81 -2 -11 65 6 -38 -27 -29
 */

#include <iostream>

void extrema(int *A, int n, int *min, int *max) {
    *min = A[0];
    *max = A[0];
    for (int i = 1; i < n; i++) {
        if (A[i] < *min) {
            *min = A[i];
        }
        if (A[i] > *max) {
            *max = A[i];
        }
    }
}

int *oddRange(int n, int *m) {
    *m = (n + 1) / 2;
    int *A = new int[*m];
    for (int i = 1; i < n + 1; i+= 2) {
        A[i/2] = i;
    }
    return A;
}

void printIntPointer(int *A, int n, std::string prefix="", std::string suffix="\n") {
    std::cout << prefix << "[";
    for (int i = 0; i < n; i++) {
        std::cout << A[i];
        if (i < n - 1) {
            std::cout << ", ";
        }
    }
    std::cout << "]" << suffix;
}

int main(int argc, char **argv) {
    int n = argc-1;
    int *A = new int[n];
    for (int i = 1; i < argc; i++) {
        A[i-1] = atoi(argv[i]);
    }

    printIntPointer(A, n);

    int min;
    int *max = new int;
    extrema(A, n, &min, max);
    std::cout << "Min(A) = " << min << "\n";
    std::cout << "Max(A) = " << *max << "\n";

    int m;
    int *B = oddRange(15, &m);
    printIntPointer(B, m, "Odds from 1 to 15: ");

    delete[] A;
    delete[] B;
    delete max;
}